//+------------------------------------------------------------------+
//| EqualVolumeBars.mq4 |
//| Copyright  2008, komposter |
//| mailto:komposterius@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, komposter"
#property link "mailto:komposterius@mail.ru"
#property indicator_chart_window

#include <WinUser32.mqh>
//----     
extern int TicksInBar=1;
extern int StartYear=2011;
extern int StartMonth=06;

datetime DayTime[100000];
double flag[100000];
int tick=1;
//+------------------------------------------------------------------+
//| |
//+------------------------------------------------------------------+
int init()
  {

   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function |
//+------------------------------------------------------------------+
int deinit()
  {//----
   
      ObjectDelete("Line_begin");
      ObjectDelete("Line_end");
//----
   return(0);
  }  
//+------------------------------------------------------------------+
//| |
//+------------------------------------------------------------------+
int start()
  {

   int year=StartYear,month=StartMonth;

   string ticks_file_name=StringConcatenate("[Ticks]\\",AccountServer(),"\\",Symbol(),"_",year,".",strMonth(month),".csv");
   int ticks_file_handle=FileOpen(ticks_file_name,FILE_READ|FILE_CSV);
//----   

   int i=0;
   if(ticks_file_handle<0)Comment(" ",GetLastError());
   if(ticks_file_handle>0)
     {
      while(!FileIsEnding(ticks_file_handle))
        {
         DayTime[i]= StrToTime  (FileReadString(ticks_file_handle)); ArrayResize(DayTime,i+2);
         flag   [i]= StrToDouble(FileReadString(ticks_file_handle)); ArrayResize(flag,   i+2);


         i++;
        }

     }
   tick=i;
   FileClose(ticks_file_handle);
//-------------------------------------------------------------   


//-------------------------------------------------------- 
   int  bar_end  =create_line("Line_end", Red);
   int  bar_begin=create_line("Line_begin",Yellow);
   
   
   if(bar_begin> bar_end) { Alert(",  Line_begin     0-    Line_end"); return(0); }
   
   

   datetime Time_begin=Time[bar_begin]+Period();
   datetime Time_end  =Time[bar_end];

   if(bar_begin==0) Time_begin=TimeCurrent();

   int up=0,dn=0,fl=0;
   for(i=0;i<tick;i++)
     {
      if(DayTime[i]<=Time_begin && DayTime[i]>=Time_end)
        {

         if(flag[i]>flag[i+1]) up++; else
         if(flag[i]<flag[i+1]) dn++; else
         if(flag[i]==flag[i+1])fl++;
        }

     }

   Comment("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nup = ",up,"\ndn = ",dn,"\nfl = ",fl);

   return(0);
  }
//+------------------------------------------------------------------+
//| |
//+------------------------------------------------------------------+

string strMonth(int m)
  {
   if(m<10)return(StringConcatenate("0",m));
   return(m);
  }
//+------------------------------------------------------------------+

int create_line(string name,color c){

   if(ObjectFind(name)<0)
     {
      ObjectCreate(name,OBJ_VLINE,0,Time[0],Close[0]);
      //ObjectSet("Line", OBJPROP_XDISTANCE, Time[1]);
      ObjectSet(name,OBJPROP_COLOR,c);
      ObjectSet(name,OBJPROP_WIDTH,1);
      WindowRedraw();
     }
   if(ObjectFind(name)>=0)
     {
      double Time_k=ObjectGet(name,OBJPROP_TIME1);
      int n;
      for(int h=0;h<Bars;h++)
        {
         if(Time[h]==Time_k) {n=h;break;}
        }
      //Alert(Time_k," ",n); 
     }
     
   return(n);  }